﻿local bs = AceLibrary("Babble-Spell-2.2")
local Tablet = AceLibrary("Tablet-2.0")
local BZ = AceLibrary("Babble-Zone-2.2")
local Tourist = AceLibrary("Tourist-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Fishing")

L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out fish"] = true,
	["Select all"] = true,
	["Select none"] = true,
	["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,
	["Show Tastyfish"] = true,
	["Show only tastyfish nodes during the fishing extraveganza"] = true,
	["Show minimap icons"] = true,
	["Show fishing icons on the minimap"] = true,
	-- fish nodes
	["Floating Wreckage"] = true,
	["Patch of Elemental Water"] = true,
	["Floating Debris"] = true,
	["Oil Spill"] = true,
	["Firefin Snapper School"] = true,
	["Greater Sagefish School"] = true,
	["Oily Blackmouth School"] = true,
	["Sagefish School"] = true,
	["School of Deviate Fish"] = true,
	["Stonescale Eel Swarm"] = true,
	["Muddy Churning Water"] = true,
	-- TBC school
	["Highland Mixed School"] = true,  
	["Pure Water"] = true,            
	["Bluefish School"] = true,
	["Feltail School"] = true, 
	["Mudfish School"] = true, 
	["School of Darter"] = true, 
	["Sporefish School"] = true,  
	["Steam Pump Flotsam"] = true, 
	-- Cartographer_Fishing contest node
	["School of Tastyfish"] = true,
	-- generic School for gatherer imports
	["School"] = true,
	-- potion fish
	["Stonescale Eel"] = true,
	["Oily Blackmouth"] = true,
	["Firefin Snapper"] = true,
	-- Fishing quest for artisan
	["Sar'theris Striker"] = true,
	["Savage Coast Blue Sailfin"] = true,
	["Misty Reed Mahi Mahi"] = true,
	["Feralas Ahi"] = true,
	-- quest fish
	["Spotted Sunfish"] = true,
	["Lightning Eel"] = true,
	["Oil Covered Fish"] = true,
	["Plated Armorfish"] = true,
	["Darkshore Grouper"] = true,
	["Electropeller"] = true,
	["Gaffer Jack"] = true,
	["Pristine Shimmerscale Eel"] = true,
	-- cookable fish
	["Raw Brilliant Smallfish"] = true,
	["Raw Bristle Whisker Catfish"] = true,
	["Raw Glossy Mightfish"] = true,
	["Raw Greater Sagefish"] = true,
	["Raw Loch Frenzy"] = true,
	["Raw Longjaw Mud Snapper"] = true,
	["Raw Mithril Head Trout"] = true,
	["Raw Nightfin Snapper"] = true,
	["Raw Rainbow Fin Albacore"] = true,
	["Raw Redgill"] = true,
	["Raw Rockscale Cod"] = true,
	["Raw Sagefish"] = true,
	["Raw Slitherskin Mackerel"] = true,
	["Raw Spotted Yellowtail"] = true,
	["Raw Summer Bass"] = true,
	["Raw Sunscale Salmon"] = true,
	["Raw Whitescale Salmon"] = true,
	["Darkclaw Lobster"] = true,
	["Deviate Fish"] = true,
	["Large Raw Mightfish"] = true,
	["Winter Squid"] = true,
	-- Cartographer_Fishing contest fish
	["Speckled Tastyfish"] = true,
	["Keefer's Angelfish"] = true,
	["Dezian Queenfish"] = true,
	["Brownell's Blue Striped Racer"] = true,
	-- tbc fish
	["Felblood Snapper"] = true,
	["Figluster's Mudfish"] = true,
	["Furious Crawdad"] = true,
	["Golden Darter"] = true,
	["Icefin Bluefish"] = true,
	["Spotted Feltail"] = true,
	["Zangarian Sporefish"] = true,
	["Goldenscale Vendorfish"] = true,

} end)

L:RegisterTranslations("deDE", function() return {

	["Filter"] = "Filter",
	["Filter out fish"] = "Fische filtern",
	["Select all"] = "Alle ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",
	["Icon alpha"] = "Transparenz",
	["Alpha transparency of the icon"] = "Transparenz der Symbole",
	["Icon size"] = "Symbolgröße",
	["Size of the icons on the map"] = "Größe der Symbole",
	["Show Tastyfish"] = "Leckerfisch anzeigen",
	["Show only tastyfish nodes during the fishing extraveganza"] = "Während des Angelwettbewerbs nur Leckerfischschwärme anzeigen.",
	-- fish nodes
	["Floating Wreckage"] = "Schwimmende Wrackteile",
	["Patch of Elemental Water"] = "Stelle mit Elementarwasser",
	["Floating Debris"] = "Schwimmende Trümmer",
	["Oil Spill"] = "Ölfleck", -- check
	["Firefin Snapper School"] = "Feuerflossenschnapperschwarm",
	["Greater Sagefish School"] = "Schwarm großer Weisenfische",
	["Oily Blackmouth School"] = "Schwarm öliger Schwarzmaulfische",
	["Sagefish School"] = "Weisenfischschwarm",
	["School of Deviate Fish"] = "Deviatfischschwarm", -- check
	["Stonescale Eel Swarm"] = "Steinschuppenaalschwarm",
	["Muddy Churning Water"] = "Schlammiges aufgewühltes Gewässer",
	-- Cartographer_Fishing contest node
	["School of Tastyfish"] = "Leckerfischschwarm",
	-- generic School for gatherer imports
	["School"] = "Schwarm",
	-- potion fis
	["Stonescale Eel"] = "Steinschuppenaal",
	["Oily Blackmouth"] = "Öliges Schwarzmaul",
	["Firefin Snapper"] = "Feuerflossenschnapper",
	-- Fishing quest for artisan
	["Sar'theris Striker"] = "Sar'theris-Barsch",
	["Savage Coast Blue Sailfin"] = "Blauwimpel von der ungezähmten Küste",
	["Misty Reed Mahi Mahi"] = "Nebelschilf-Mahi-Mahi",
	["Feralas Ahi"] = "Feralas Ahi",
	-- quest fish
	["Spotted Sunfish"] = "Gefleckter Sonnenfisch",
	["Lightning Eel"] = "Zitteraal",
	["Oil Covered Fish"] = "Ölbedeckter Fisch",
	["Plated Armorfish"] = "Panzerfisch",
	["Darkshore Grouper"] = "Dunkelküstenbarsch",
	["Electropeller"] = "Elektropeller", 
	["Gaffer Jack"] = "Klemm-Muffen",
--	["Pristine Shimmerscale Eel"] = true, TODO (not found on wowguru)
	-- cookable fish
	["Raw Brilliant Smallfish"] = "Roher glänzender Kleinfisch",
	["Raw Bristle Whisker Catfish"] = "Roher Stoppelfühlerwels",
	["Raw Glossy Mightfish"] = "Roher glänzender Machtfisch",
	["Raw Greater Sagefish"] = "Roher großer Weisenfisch",
	["Raw Loch Frenzy"] = "Roher Lochfrenzy",
	["Raw Longjaw Mud Snapper"] = "Roher langzahniger Matschschnapper",
	["Raw Mithril Head Trout"] = "Rohe Mithrilkopfforelle",
	["Raw Nightfin Snapper"] = "Roher Nachtflossenschnapper",
	["Raw Rainbow Fin Albacore"] = "Roher Regenbogenflossenthunfisch",
	["Raw Redgill"] = "Roher Regenbogenflossenthunfisch",
	["Raw Rockscale Cod"] = "Roher Steinschuppenkabeljau",
	["Raw Sagefish"] = "Roher Weisenfisch",
	["Raw Slitherskin Mackerel"] = "Rohe Glitschhautmakrele",
	["Raw Spotted Yellowtail"] = "Roher Tüpfelgelbschwanz",
	["Raw Summer Bass"] = "Roher Sommerbarsch",
	["Raw Sunscale Salmon"] = "Roher Sonnenschuppenlachs",
	["Raw Whitescale Salmon"] = "Roher Weißschuppenlachs",
	["Darkclaw Lobster"] = "Dunkelklauenhummer",
	["Deviate Fish"] = "Deviatfisch",
	["Large Raw Mightfish"] = "Großer roher Machtfisch",
	["Winter Squid"] = "Winterkalmar",
	-- Cartographer_Fishing contest fish
	["Speckled Tastyfish"] = "Gesprenkelter Leckerfisch",
	["Keefer's Angelfish"] = "Keefers Engelfisch",
	["Dezian Queenfish"] = "Dezianischer Königinnenfisch",
	["Brownell's Blue Striped Racer"] = "Brownells blaugestreifter Flitzerfisch",
-- tbc school	
	--["Highland Mixed School"] = true,  
	["Pure Water"] = "Reines Wasser",
	["Bluefish School"] = "Blauflossenschwarm",
	["Feltail School"] = "Teufelsfinnenschwarm", 
	["Mudfish School"] = "Matschflosserschwarm",
	--["School of Darter"] = true, 
	["Sporefish School"] = "Sporenfischschwarm",
	--["Steam Pump Flotsam"] = true,
  -- tbc fish
--	["Felblood Snapper"] = true,
	["Figluster's Mudfish"] = "Feigenschimmers Matschflosser",
--	["Furious Crawdad"] = true,
--	["Golden Darter"] = true,
	["Icefin Bluefish"] = "Eisblauflosse",
	["Spotted Feltail"] = "Tüpfelteufelsfinne",
	["Zangarian Sporefish"] = "Zangarischer Sporenfisch",
--	["Goldenscale Vendorfish"] = true,
} end)

L:RegisterTranslations("frFR", function() return {
	["Filter"] = "Filtrer",
	["Select all"] = "S\195\169lectinner toutes",
	["Select none"] = "S\195\169lectinner aucune",
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터링",
--	["Filter out fish"] = true,
	["Select all"] = "모두 선택",
	["Select none"] = "선택 해제",
	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
--	["Show Tastyfish"] = true,
--	["Show only tastyfish nodes during the fishing extraveganza"] = true,
	-- fish nodes
	["Floating Wreckage"] = "표류하는 잔해",
	["Patch of Elemental Water"] = "정기가 흐르는 물웅덩이",
--	["Floating Debris"] = true,
	["Oil Spill"] = "기름기 많은",
--	["Firefin Snapper School"] = true,
--	["Greater Sagefish School"] = true,
--	["Oily Blackmouth School"] = true,
--	["Sagefish School"] = true,
--	["School of Deviate Fish"] = true,
--	["Stonescale Eel Swarm"] = true,
--	["Muddy Churning Water"] = true,
	-- TBC school
--	["Highland Mixed School"] = true,  
--	["Pure Water"] = true,            
--	["Bluefish School"] = true,
--	["Feltail School"] = true, 
--	["Mudfish School"] = true, 
--	["School of Darter"] = true, 
--	["Sporefish School"] = true,  
--	["Steam Pump Flotsam"] = true, 
	-- Cartographer_Fishing contest node
--	["School of Tastyfish"] = true,
	-- generic School for gatherer imports
	["School"] = "떼",
	-- potion fish
	["Stonescale Eel"] = "돌비늘뱀장어",
	["Oily Blackmouth"] = "기름기 많은 아귀",
	["Firefin Snapper"] = "불지느러미퉁돔",
	-- Fishing quest for artisan
	["Sar'theris Striker"] = "살데리스 아귀",
	["Savage Coast Blue Sailfin"] = "폭풍 해안 푸른도루묵",
	["Misty Reed Mahi Mahi"] = "안개갈대 황새치",
	["Feralas Ahi"] = "페랄라스 참치",
	-- quest fish
	["Spotted Sunfish"] = "점박이 개복치",
	["Lightning Eel"] = "번개뱀장어",
	["Oil Covered Fish"] = "기름으로 범벅된 물고기",
	["Plated Armorfish"] = "무쇠비늘 철갑어",
	["Darkshore Grouper"] = "어둠의해안 농어",
	["Electropeller"] = "전력추진기",
	["Gaffer Jack"] = "개퍼 잭",
--	["Pristine Shimmerscale Eel"] = true,
	-- cookable fish
	["Raw Brilliant Smallfish"] = "비단잉어",
	["Raw Bristle Whisker Catfish"] = "표범메기",
	["Raw Glossy Mightfish"] = "빛깔좋은 망둥어",
	["Raw Greater Sagefish"] = "대형 총명어",
	["Raw Loch Frenzy"] = "호수프렌지",
	["Raw Longjaw Mud Snapper"] = "긴주둥이진흙퉁돔",
	["Raw Mithril Head Trout"] = "미스릴송어",
	["Raw Nightfin Snapper"] = "밤비늘퉁돔",
	["Raw Rainbow Fin Albacore"] = "무지개날개다랑어",
	["Raw Redgill"] = "붉은퉁돔",
	["Raw Rockscale Cod"] = " 돌비늘대구",
	["Raw Sagefish"] = "총명어",
	["Raw Slitherskin Mackerel"] = " 줄무늬고등어",
	["Raw Spotted Yellowtail"] = "점박이놀래기",
	["Raw Summer Bass"] = "넙치농어",
	["Raw Sunscale Salmon"] = "해비늘연어",
	["Raw Whitescale Salmon"] = " 유리비늘연어 ",
	["Darkclaw Lobster"] = "검은발톱 랍스터",
	["Deviate Fish"] = "돌연변이 물고기",
	["Large Raw Mightfish"] = "큰 망둥어",
	["Winter Squid"] = "겨울오징어",
	-- Cartographer_Fishing contest fish
	["Speckled Tastyfish"] = "점박이맛둥어",
	["Keefer's Angelfish"] = "키퍼의 천사돔",
	["Dezian Queenfish"] = "데지안 여왕물고기",
	["Brownell's Blue Striped Racer"] = "브로넬의 푸른줄무늬날치",
	-- tbc fish
--	["Felblood Snapper"] = true,
--	["Figluster's Mudfish"] = true,
--	["Furious Crawdad"] = true,
--	["Golden Darter"] = true,
--	["Icefin Bluefish"] = true,
--	["Spotted Feltail"] = true,
--	["Zangarian Sporefish"] = true,
--	["Goldenscale Vendorfish"] = true,
} end)


L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtro",
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
	["Icon alpha"] = "Transparencia de icono",
	["Alpha transparency of the icon"] = "Transparencia de los iconos",
	["Icon size"] = "Tama\195\177o de icono",
	["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
	["Show Tastyfish"] = "Mostrar Pezrico moteado",
	["Show only tastyfish nodes during the fishing extraveganza"] = "Muestra solo los nodos de pezrico moteado durante el concurso de pesca",
	["Show minimap icons"] = "Mostrar iconos en minimapa",
	["Show fishing icons on the minimap"] = "Muestra los iconos de pesca en el minimapa",
} end)



-- this is not local so import can call some of the functions in this mod

Cartographer_Fishing = Cartographer:NewModule("Fishing", "AceConsole-2.0", "AceEvent-2.0")

Cartographer_Fishing.icon = {
	["Floating Wreckage"] = {
		text = L["Floating Wreckage"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Treasure",
		width = 12,
		height = 12,
	},
	["Patch of Elemental Water"] = {
		text = L["Patch of Elemental Water"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\WaterPatch",
		width = 12,
		height = 12,
	},
	["Floating Debris"] = {
		text = L["Floating Debris"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Debris",
		width = 12,
		height = 12,
	},
	["Oil Spill"] = {
		text = L["Oil Spill"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\OilSpill",
		width = 12,
		height = 12,
	},
	["Firefin Snapper School"] = {
		text = L["Firefin Snapper School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Firefin",
		width = 12,
		height = 12,
	},
	["Greater Sagefish School"] = {
		text = L["Greater Sagefish School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\GreatesageFish",
		width = 12,
		height = 12,
	},
	["Oily Blackmouth School"] = {
		text = L["Oily Blackmouth School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\OilyBlackmouth",
		width = 12,
		height = 12,
	},
	["Sagefish School"] = {
		text = L["Sagefish School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Sagefish",
		width = 12,
		height = 12,
	},
	["School of Deviate Fish"] = {
		text = L["School of Deviate Fish"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Net",
		width = 12,
		height = 12,
	},
	["School"] = {
		text = L["School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Net",
		width = 12,
		height = 12,
	},
	["School of Tastyfish"] = {
		text = L["School of Tastyfish"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\FishHook",
		width = 12,
		height = 12,
	},
	["Stonescale Eel Swarm"] = {
		text = L["Stonescale Eel Swarm"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Eel",
		width = 12,
		height = 12,
	},
	["Muddy Churning Water"] = {
		text = L["Muddy Churning Water"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Net",
		width = 12,
		height = 12,		
	},
	["Pure Water"] = {
		text = L["Pure Water"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\PureWater",
		width = 12,
		height = 12,
	},
	["Highland Mixed School"] = {
		text = L["Highland Mixed School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\CrawDad",
		width = 12,
		height = 12,				
	},
	["Bluefish School"] = {
		text = L["Bluefish School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\BlueFish",
		width = 12,
		height = 12,
	},
	["Feltail School"] = {
		text = L["Feltail School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\FelTail",
		width = 12,
		height = 12,
	},
	["Mudfish School"] = {
		text = L["Mudfish School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Mudfish",
		width = 12,
		height = 12,
	},
	["School of Darter"] = {
		text = L["School of Darter"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Darter",
		width = 12,
		height = 12,
	},
	["Sporefish School"] = {
		text = L["Sporefish School"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\Sporefish",
		width = 12,
		height = 12,
	},
	["Steam Pump Flotsam"] = {
		text = L["Steam Pump Flotsam"],
		path = "Interface\\Addons\\Cartographer_Fishing\\Artwork\\SteamPump",
		width = 12,
		height = 12,
	},
}

Cartographer_Fishing.isFishing = false

Cartographer_Fishing.nodeList = {
	[L["Floating Wreckage"]] = "Floating Wreckage",
	[L["Patch of Elemental Water"]] = "Patch of Elemental Water",
	[L["Floating Debris"]] = "Floating Debris",
	[L["Oil Spill"]] = "Oil Spill",
	[L["Firefin Snapper School"]] = "Firefin Snapper School",
	[L["Greater Sagefish School"]] = "Greater Sagefish School",
	[L["Oily Blackmouth School"]] = "Oily Blackmouth School",
	[L["Sagefish School"]] = "Sagefish School",
	[L["School of Deviate Fish"]] = "School of Deviate Fish",
	[L["School of Tastyfish"]] = "School of Tastyfish",
	[L["Stonescale Eel Swarm"]] = "Stonescale Eel Swarm",
	[L["Highland Mixed School"]] = "Highland Mixed School",
	[L["Pure Water"]] = "Pure Water",
	[L["Bluefish School"]] = "Bluefish School",
	[L["Feltail School"]] = "Feltail School",
	[L["Mudfish School"]] = "Mudfish School",
	[L["School of Darter"]] = "School of Darter",
	[L["Sporefish School"]] = "Sporefish School",
	[L["Steam Pump Flotsam"]] = "Steam Pump Flotsam",
}

Cartographer_Fishing.questFish = {
	[L["Sar'theris Striker"]] = true,
	[L["Savage Coast Blue Sailfin"]] = true,
	[L["Misty Reed Mahi Mahi"]] = true,
	[L["Feralas Ahi"]] = true,
	[L["Spotted Sunfish"]] = true,
	[L["Darkshore Grouper"]] = true,
	[L["Electropeller"]] = true,
	[L["Gaffer Jack"]] = true,
	[L["Pristine Shimmerscale Eel"]] = true,
	[L["Speckled Tastyfish"]] = true,
	[L["Keefer's Angelfish"]] = true,
	[L["Dezian Queenfish"]] = true,
	[L["Brownell's Blue Striped Racer"]] = true,
}

function Cartographer_Fishing:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Fishing")
	Cartographer:RegisterDefaults("Fishing", "profile", {
		filter = {
			['*'] = true,
		},
		iconAlpha = 1,
		iconScale = 1,
		showContest = false,
		minicons = true,
	})

	local aceopts = {}
	aceopts.trans = {
		name = L["Icon alpha"],
		desc = L["Alpha transparency of the icon"],
		type = 'range',
		min = 0.1,
		max = 1,
		step = 0.05,
		isPercent = true,
		get = "GetIconAlpha",
		set = "SetIconAlpha",
		order = 1
	}
	aceopts.scal = {
		name = L["Icon size"],
		desc = L["Size of the icons on the map"],
		type = 'range',
		min = 0.5,
		max = 2,
		step = 0.05,
		isPercent = true,
		get = "GetIconScale",
		set = "SetIconScale",
		order = 1
	}
	aceopts.minicons = {
		name = L["Show minimap icons"],
		desc = L["Show fishing icons on the minimap"],
		type = 'toggle',
		set = "ToggleShowingMinimapIcons",
		get = "IsShowingMinimapIcons",
		order = 1,
	}
	aceopts.contest = {
		name = L["Show Tastyfish"],
		desc = L["Show only tastyfish nodes during the fishing extraveganza"],
		type = 'toggle',
		order = 300,
		get = 'GetShowWhenContest',
		set = 'ToggleShowWhenContest',
	}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}
	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out fish"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingFish(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingFish(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		aceopts.filter.args[k] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingFish(k)
			end,
			set = function(value)
				return self:ToggleShowingFish(k, value)
			end,
		}
	end
	Cartographer.options.args["Fishing"] = {
		name = bs["Fishing"],
		desc = self.notes,
		type = 'group',
		args = aceopts,
		handler = self,
	}
	AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Fishing"])
	Cartographer:GetModule('Professions').addons[bs["Fishing"]] = self
	
	if not Cartographer_FishingDB then
		Cartographer_FishingDB = {}
		Cartographer_FishingDB.nodes = {}
		Cartographer_FishingDB.fish = {}
	end
	if not Cartographer_FishingDB.nodes then
		Cartographer_FishingDB.nodes = {}
	end
	if not Cartographer_FishingDB.fish then
		Cartographer_FishingDB.fish = {}
	else -- fix unlocalizaed names
		for _,zone in pairs(Cartographer_FishingDB.fish) do
			if type(zone) == "table" then
				for id,fish in ipairs(zone) do
					if L:HasReverseTranslation(fish) then
						local newName = L:GetReverseTranslation(fish)
						zone[id] = newName
					end
				end
			end
		end
	end
end


function Cartographer_Fishing:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end
		
		Cartographer_Notes:RegisterNotesDatabase('Fishing', Cartographer_FishingDB.nodes, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end
	
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	self:RegisterEvent("CURSOR_UPDATE")
	self:RegisterEvent("LOOT_OPENED")
end

function Cartographer_Fishing:OnDisable()
	self:UnregisterAllEvents()
	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Fishing')
	end
end

function Cartographer_Fishing:SetNote(what)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	what = what:gsub("^(.-) %(%d+%)$", "%1")
	what = self.nodeList[what]  --L:GetReverseTranslation(what)
	-- cursor direction
	local currentYardWidth, currentYardHeight = Tourist:GetZoneYardSize(GetRealZoneText())
	local model = self:GetPlayerModelRef()
	local rad = model:GetFacing() + (1.0 * math.pi)
	x,y = x * currentYardWidth, y * currentYardHeight
	x,y = x+math.sin(rad)*30, y+math.cos(rad)*30
	x,y = x/currentYardWidth,y/currentYardHeight
	-- calculated a trget 30 yards out (max fish range)
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 30, "Fishing", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Fishing")
end

function Cartographer_Fishing:OnNoteTooltipRequest(zone, id, fish, minimap)
	Tablet:SetTitle(L[fish])
	Tablet:SetTitleColor(0, 0.8, 0)
	
	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', bs["Fishing"]
		)
	end
end

function Cartographer_Fishing:UNIT_SPELLCAST_CHANNEL_START(unit)
	if unit ~= "player" then
		return
	end
	local spell, _, text, _, _, _  = UnitChannelInfo("player") 
	if spell then
		if spell:match(bs["Fishing"]) then
			self.isFishing = true
		end
	end
end
function Cartographer_Fishing:GetPlayerModelRef()
	local isModel = {Minimap:GetChildren()};
	for yes=getn(isModel), 1, -1 do
		if ( ( isModel[yes]:IsObjectType("Model") ) and ( not isModel[yes]:GetName() ) ) then
			return isModel[yes];
		end
	end
end

function Cartographer_Fishing:UNIT_SPELLCAST_CHANNEL_STOP()
	self.isFishing = false
end
function Cartographer_Fishing:CURSOR_UPDATE()
	local what = GameTooltipTextLeft1:GetText();
	if what and self.isFishing then
		if self.nodeList[what] then
			self:SetNote(what)
		end
	end
end

function Cartographer_Fishing:LOOT_OPENED()
	if IsFishingLoot() then
		for idx = 1, GetNumLootItems(), 1 do
			if LootSlotIsItem(idx) then
				local lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(idx);
				-- fishname is found as lootName
				-- can we translate this name from our fish list
				if L:HasReverseTranslation(lootName) then
					local zone = GetRealZoneText()
					zone =  BZ:GetReverseTranslation(zone)
					-- Babble zone doesnt have translations for sub zones
					-- local subZone = GetSubZoneText()
					-- gota change this for localization conversion
					local key = zone
					if not Cartographer_FishingDB.fish[key] then
						Cartographer_FishingDB.fish[key] = {}
					end
					-- lets skip quest fish and contest fish since we only catch them once OR they only exist in 1 zone
					-- the quest fish list is a list of localizaed fish names thats built when the client loads
					-- so we need to look them up by their actual localized name
					if not self.questFish[lootName] then
						local stable = Cartographer_FishingDB.fish[key]
						--stable:insert(lootName)
						table.insert(stable,L:GetReverseTranslation(lootName))
						self:TriggerEvent("CartographerFishing_CaughtFish", key, x, y, L:GetReverseTranslation(lootName),"Fishing")
					end
				end
			end
		end
	end
end

function Cartographer_Fishing:IsContestTime()
	temp = date("*t", time())
	hours,minutes = GetGameTime();
	return (temp.wday == 0) and (hours >= 14 or hours <= 16)
end

function Cartographer_Fishing:IsNoteHidden(zone, id, fish)
	if self:IsContestTime() and self.db.profile.showContest and fish ~= "School of Tastyfish" then
		return false
	end
	return not self.db.profile.filter[fish]
end

function Cartographer_Fishing:IsShowingFish(fish)
	return self.db.profile.filter[fish]
end

function Cartographer_Fishing:ToggleShowingFish(fish, value)
	if value == nil then
		value = not self.db.profile.filter[fish]
	end
	self.db.profile.filter[fish] = value
	Cartographer_Notes:RefreshMap()
end

function Cartographer_Fishing:ToggleShowWhenContest()
	self.db.profile.showContest = not self.db.profile.showContest
end
function Cartographer_Fishing:GetShowWhenContest()
	return self.db.profile.showContest
end

function Cartographer_Fishing:GetIconScale()
	return self.db.profile.iconScale
end

function Cartographer_Fishing:SetIconScale(value)
	self.db.profile.iconScale = value
	Cartographer_Notes:RefreshMap()
end
function Cartographer_Fishing:GetIconAlpha()
	return self.db.profile.iconAlpha
end

function Cartographer_Fishing:SetIconAlpha(value)
	self.db.profile.iconAlpha = value
	Cartographer_Notes:RefreshMap()
end

function Cartographer_Fishing:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end
function Cartographer_Fishing:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end
function Cartographer_Fishing:IsShowingMinimapIcons()
	return self.db.profile.minicons
end
function Cartographer_Fishing:ToggleShowingMinimapIcons()
	self.db.profile.minicons = not self.db.profile.minicons
end
function Cartographer_Fishing:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minicons
end